function void HUD_Classic(int baseID, int blueCoins, int bluePrev, int blueGain, int redCoins, int redPrev, int redGain, int myCoins)
{
    int middleMarker;

    SetHudSize(320, 240, 1);

    // ONE LINERS
    //  - Get cvar, clamped between 0 and 10000
    //  - Scale it so that 0-10000 is 0-320 for X and 0-240 for Y
    //  - Make it fixed
    int baseX = itof(FixedDiv(middle(0, SB_GetCVar("sb_cl_hudx"), 10000), 1000.0/32));     // center
    int baseY = itof(FixedDiv(middle(0, SB_GetCVar("sb_cl_hudy"), 10000), 1000.0/24));     // top
    int tmpX, tmpY;

    switch (intcmp(blueCoins, redCoins))
    {
        case -1: middleMarker = ">>>>"; break;
        default: middleMarker = "----"; break;
        case  1: middleMarker = "<<<<"; break;
    }

    SetFont("BIGFONT");

    HudMessage(d:blueCoins;     HUDMSG_PLAIN, baseID+5, CR_BLUE,   baseX - 29.8,    baseY + 0.1, 0);
    HudMessage(d:redCoins;      HUDMSG_PLAIN, baseID+6, CR_RED,    baseX + 30.1,    baseY + 0.1, 0);
    HudMessage(s:middleMarker;  HUDMSG_PLAIN, baseID+3, CR_WHITE,  baseX + 0.4,     baseY + 0.1, 0);
    
    if (blueGain)
    {
        tmpX = (baseX - 45.0) + 0.2;
        tmpY = (baseY + 16.0) + 0.1;

        HudMessage(s:cond(blueGain >= 0, "+", "\cm-"), s:"$", d:blueGain;
                    HUDMSG_FADEOUT, baseID+1, CR_LIGHTBLUE, tmpX, tmpY, 0.5, 0.5);
    }

    if (redGain)
    {
        tmpX = (baseX + 45.0) + 0.1;
        tmpY = (baseY + 16.0) + 0.1;

        HudMessage(s:cond(redGain >= 0, "+", "\cm-"), s:"$", d:redGain;
                    HUDMSG_FADEOUT, baseID+2, CR_BRICK, tmpX, tmpY, 0.5, 0.5);
    }

    if (myCoins == -1)
    {
        HudMessage(s:"$\cu????"; HUDMSG_PLAIN, baseID+4, CR_GOLD, baseX + 0.4, baseY + 16.1, 1.0);
    }
    else
    {
        HudMessage(s:"$", d:myCoins; HUDMSG_PLAIN, baseID+4, CR_GOLD, baseX + 0.4, baseY + 16.1, 1.0);
    }
}

function void HUD_Compact(int baseID, int blueCoins, int bluePrev, int blueGain, int redCoins, int redPrev, int redGain, int myCoins)
{
    int middleColor;

    SetHudSize(480, 360, 1);

    int baseX = itof(FixedDiv(middle(0, SB_GetCVar("sb_cl_hudx"), 10000), 1000.0/48));     // center
    int baseY = itof(FixedDiv(middle(0, SB_GetCVar("sb_cl_hudy"), 10000), 1000.0/36));     // center

    SetFont("BIGFONT");

    HudMessage(d:blueCoins;     HUDMSG_PLAIN, baseID+5, CR_BLUE,      baseX + 0.4,  baseY - 15.8,    0);
    HudMessage(d:redCoins;      HUDMSG_PLAIN, baseID+6, CR_RED,       baseX + 0.4,  baseY + 16.1,    0);
    HudMessage(s:"";            HUDMSG_PLAIN, baseID+3, CR_RED,       baseX + 0.4,  baseY + 4.1,    0);
    
    if (blueGain)
    {
        HudMessage(d:blueCoins; HUDMSG_FADEOUT, baseID+1, CR_LIGHTBLUE, baseX + 0.4, baseY - 15.8, 0.0, 0.5);
    }

    if (redGain)
    {
        HudMessage(d:redCoins;  HUDMSG_FADEOUT, baseID+2, CR_BRICK,     baseX + 0.4, baseY + 16.1, 0.0, 0.5);
    }

    if (myCoins == -1)
    {
        HudMessage(s:"$\cu????"; HUDMSG_PLAIN, baseID+4, CR_GOLD, baseX + 0.4, baseY, 1.0);
    }
    else
    {
        HudMessage(s:"$", d:myCoins; HUDMSG_PLAIN, baseID+4, CR_GOLD, baseX + 0.4, baseY, 1.0);
    }
}
