#include "zcommon.acs"
#library "skullbag"

#include "commonFuncs.h"
#include "cvar.h"
#include "skullConst.h"
#include "skullFuncs.h"
#include "spawnpoints.h"
#include "hud.h"

script 49 (int whichTeam, int notPillar)
{
    int pln = PlayerNumber();
    int plt = GetPlayerInfo(pln, PLAYERINFO_TEAM);
    int teampoints;

    if (whichTeam != plt) { terminate; }

    int coincount = CheckInventory("SkullCoin");

    if (!notPillar)
    {
        int toPoint = ValidSpawnIndex();

        if (toPoint != -1)
        {
            Spawn("NotFatassTeleportFog", GetActorX(0), GetActorY(0), GetActorZ(0));

            int x = SpawnPoints[toPoint][0];
            int y = SpawnPoints[toPoint][1];
            int z = SpawnPoints[toPoint][2];
            int a = SpawnPoints[toPoint][3];
            SetActorVelocity(0, 0,0,0, 0, 0);
            SetActorPosition(0, x, y, z, 0);
            SetActorAngle(0, a);

            Spawn("NotFatassTeleportFog", x + (8 * cos(a)), y + (8 * sin(a)), z);
        }
    }
    else
    {
        Teleport(TeamTeleportPoints[plt], 0, 0);
    }

    if (coincount)
    {
        TakeInventory("SkullCoin", 0x7FFFFFFF);
        SetActivator(0);

        int i;
        int coinsGiven = 0;
        int loops = 0;
        int step = 5;
        int inGame = 1;
        int hasWon, won = 0;

        TickDownCount[pln] += coincount;

        for (i = step; i < coincount; i += step)
        {
            if (!PlayerInGame(pln) && inGame) { inGame = 0; }
            if (inGame)
            {
                TickDownCount[pln] -= step;
                ACS_ExecuteAlways(58, 0, 1, pln, TickDownCount[pln]);
            }

            teampoints = GetTeamProperty(plt, TPROP_PointCount);
            hasWon = won;
            won    = hasWon || GameWon(teampoints + step);

            if (won && !hasWon) { Team_GivePoints(plt, coincount - coinsGiven, 0); }
            else if (!won) { Team_GivePoints(plt, step, 0); }

            TeamCoinCounts[plt] += step;
            coinsGiven += step;

            if (LastTickSound + 3 <= Timer())
            {
                AmbientSound("skullbag/cashingin", 96);
                LastTickSound = Timer();
            }

            loops += 1;
            step = 5 + pow(1 * (loops / 3), 2);
            Delay(3);
        }

        i = coincount - coinsGiven;
        teampoints = GetTeamProperty(plt, TPROP_PointCount);

        if (i)
        {
            if (!GameWon(teampoints)) { Team_GivePoints(plt, i, 0); }
            TeamCoinCounts[plt] += i;

            if (!PlayerInGame(pln) && inGame) { inGame = 0; }
            if (inGame)
            {
                TickDownCount[pln] -= i;
                ACS_ExecuteAlways(58, 0, 1, pln, TickDownCount[pln]);
            }
        }

        AmbientSound("skullbag/cashedin", 96);
    }
}

script 50 (void)
{
    ACS_ExecuteWithResult(49, 0, 1);
}

script 51 (void)
{
    ACS_ExecuteWithResult(49, 1, 1);
}

script 52 OPEN clientside
{
    if (GameType() == GAME_TITLE_MAP) { terminate; }

    int blueCoins, redCoins;
    int bluePrev,  redPrev;
    int blueLast,  redLast;
    int blueLead,  redLead;
    int tic;
    int i;

    Client_MyCoins = -1;

    if (!SB_GetCvar("sb_cl_runbefore"))
    {
        SB_SetCVar("sb_cl_runbefore", 1);

        if (!SB_Cvarinfo())
        {
            SB_SetCVar("sb_cl_hudx", 5000);
            SB_SetCVar("sb_cl_hudy", 500);
            SB_SetCVar("sb_cl_hudtype", 0);
        }
    }

    while (1)
    {
        /////
        /// SET MAIN VALUES HERE
        /////

        tic = Timer();

        blueCoins = condFalse(TeamCoinCounts[0], GetTeamProperty(0, TPROP_PointCount));
        redCoins  = condFalse(TeamCoinCounts[1], GetTeamProperty(1, TPROP_PointCount));

        bluePrev  = Client_LastCoins[0];
        redPrev   = Client_LastCoins[1];

        if (!PlayerInGame(ConsolePlayerNumber()))
        {
            Client_MyCoins = -1;
        }

        i = blueCoins - bluePrev;
        if (i)
        {
            blueLead += i;
            blueLast = tic;
        }
        if (blueLast + 24 < tic) { blueLead = 0; }


        i = redCoins - redPrev;
        if (i)
        {
            redLead += i;
            redLast = tic;
        }
        if (redLast + 24 < tic) { redLead = 0; }


        switch (SB_GetCVar("sb_cl_hudtype"))
        {
          default:
            HUD_Classic(0, blueCoins, bluePrev, cond(blueLast == tic, blueLead, 0),
                           redCoins,  redPrev,  cond(redLast  == tic, redLead,  0),
                           Client_MyCoins);
            break;

          case 1:
            HUD_Compact(0, blueCoins, bluePrev, cond(blueLast == tic, blueLead, 0),
                           redCoins,  redPrev,  cond(redLast  == tic, redLead,  0),
                           Client_MyCoins);
            break;
        }

        Client_LastCoins[0] = blueCoins;
        Client_LastCoins[1] = redCoins;

        Delay(1);
    }
}

script 59 OPEN
{
    IsServer = 1;

    int blueCoins, bluePoints;
    int redCoins,  redPoints;
    int lastRed  = -1;
    int lastBlue = -1;
    int blueOver;
    int redOver;
    int pointlimit;
    int lastSend = 0x7FFFFFFF;
    int send;

    while (1)
    {
        blueCoins  = TeamCoinCounts[0];
        bluePoints = GetTeamProperty(0, TPROP_PointCount);
        redCoins   = TeamCoinCounts[1];
        redPoints  = GetTeamProperty(1, TPROP_PointCount);

        pointlimit = GetCVar("pointlimit");

        if (pointlimit <= 0)
        {
            blueOver = 0;
            redOver  = 0;
        }
        else
        {
            blueOver = blueCoins >= GetCVar("pointlimit");
            redOver  =  redCoins >= GetCVar("pointlimit");
        }

        send = 0;
        send = send || (blueOver && (blueCoins != lastBlue));
        send = send || (blueOver && (lastSend + 35 <= Timer()));
        send = send || (redOver  &&  (redCoins != lastRed));
        send = send || (redOver  && (lastSend + 35 <= Timer()));

        if (send)
        {
            ACS_ExecuteAlways(58, 0, 0, blueCoins, redCoins);

            lastSend = Timer();
            lastBlue = blueCoins;
            lastRed  = redCoins;
        }

        Delay(1);
    }
}

script 53 (int respawning)
{
    if (GameType() == GAME_TITLE_MAP) { terminate; }

    int pln = PlayerNumber();
    RegisterSpawnIndex();

    int myLock = ++SpawnLocks[pln];

    int health = GetActorProperty(0, APROP_Health), oldHealth;
    int healthDrop;
    int healthDrop_alive, healthDrop_dead;
    int coinBuffer_alive = 0;
    int coinBuffer_dead  = 0;
    int coinBuffer_alive_frac = 0;
    int coinBuffer_dead_frac  = 0;
    int carryOver = 0;
    int coinSpew;
    int alivemult, deadmult;
    int alivemult_frac, deadmult_frac;
    int i;

    while (SpawnLocks[pln] == myLock)
    {
        oldHealth = health;
        health    = GetActorProperty(0, APROP_Health);

        healthDrop = max(0, oldHealth - health);
        healthDrop_alive = max(0, min(oldHealth, healthDrop));
        healthDrop_dead  = healthDrop - healthDrop_alive;

        alivemult = SB_GetAliveMult();
        deadmult  = SB_GetDeadMult();

        alivemult_frac = alivemult % 1.0;
        deadmult_frac  = deadmult  % 1.0;

        alivemult >>= 16;
        deadmult  >>= 16;

        coinBuffer_alive += healthDrop_alive * alivemult;
        coinBuffer_dead  += healthDrop_dead  * deadmult;

        coinBuffer_alive_frac += healthDrop_alive * alivemult_frac;
        coinBuffer_dead_frac  += healthDrop_dead * deadmult_frac;

        coinBuffer_alive += ftoi(coinBuffer_alive_frac);
        coinBuffer_dead  += ftoi(coinBuffer_dead_frac);

        coinBuffer_alive_frac %= 1.0;
        coinBuffer_dead_frac  %= 1.0;

        coinSpew = carryOver;

        // Alive
        i = coinBuffer_alive / HPTOCOIN_ALIVE;
        coinSpew += i;
        coinBuffer_alive -= (i * HPTOCOIN_ALIVE);
        
        // Dead
        
        if (health <= 0)
        {
            if (CheckInventory("SkullCoin"))
            {
                coinSpew += CheckInventory("SkullCoin");
                TakeInventory("SkullCoin", 0x7FFFFFFF);
            }

            if (ACS_ExecuteWithResult(57, 0) != pln)
            {
                if (oldHealth > 0) { coinSpew += (BASEDEATHCOINS * deadmult); }
                i = coinBuffer_dead / HPTOCOIN_DEAD;
                coinSpew += min((MAXDEATHBONUS * deadmult), i);
                coinBuffer_dead = 0;
            }
        }

        int sparkleThreshold = FixedMul(100, (itof(alivemult + deadmult) + alivemult_frac + deadmult_frac) >> 1);

        if ((CheckInventory("SkullCoin") >= sparkleThreshold) && (Timer() % 3 == 0))
        {
            for (i = 0; i < 2; i++)
            {
                int a = (GetActorAngle(0) + 0.5) + random(-0.15, 0.15);
                int d = random(16, 32);
                int x = GetActorX(0) + (d * cos(a));
                int y = GetActorY(0) + (d * sin(a));
                int z = GetActorZ(0) + random(4.0, 52.0);
                a = Sparkles[random(0, SPARKLECOUNT-1)];
                Spawn(a, x, y, z);
            }
        }

        if (coinSpew) { carryOver = SpewCoins(coinSpew); }

        Delay(1);
	}
}


script 60 ENTER clientside
{
    int pln = PlayerNumber();
    if (pln != ConsolePlayerNumber()) { terminate; }

    int mylock = ++Client_SpawnLocks[pln];

    while (!(ClassifyActor(0) & ACTOR_WORLD) && (Client_SpawnLocks[pln] == mylock))
    {
        int coinshow = CheckInventory("SkullCoin") + TickDownCount[pln];
        Client_MyCoins = coinshow;
        Delay(1);
    }
}

script 54 enter
{
    ACS_ExecuteWithResult(53, 0);
}

script 55 respawn
{
    ACS_ExecuteWithResult(53, 1);
}

script 56 (int pln) disconnect
{
    if (GameType() == GAME_TITLE_MAP) { terminate; }
    SpawnLocks[pln] = 0;
    TickDownCount[pln] = 0;
}

script 57 (int which, int a1, int a2)
{
    int ret = 0;

    switch (which)
    {
      case 0:
        SetActivatorToTarget(0);
        ret = PlayerNumber();
        break;

      case 1:
        Delay(12);
        GiveInventory("AllowCoinPickup", 1);
        break;

      case 2:
        Delay(140);

        if (GetActorProperty(0, APROP_RenderStyle) == STYLE_Normal)
        {
            SetActorProperty(0, APROP_RenderStyle, STYLE_Translucent);
        }

        while (!(ClassifyActor(0) & ACTOR_WORLD))
        {
            AddActorProperty(0, APROP_Alpha, -0.01);
            if (GetActorProperty(0, APROP_Alpha) <= 0.1) { break; }
            Delay(8);
        }

        Thing_Remove(0);
    }

    SetResultValue(ret);
}

script 58 (int which, int a1, int a2) clientside
{
    int ret = 0;

    switch (which)
    {
      case 0:
        if (IsServer) { break; }
        TeamCoinCounts[0] = a1;
        TeamCoinCounts[1] = a2;
        break;

      case 1:
        if (IsServer) { break; }
        TickDownCount[a1] = a2;
        break;
    }

    SetResultValue(ret);
}
