#define SPAWNCOUNT  256

int SpawnPoints[SPAWNCOUNT][4];
int SpawnTeams[SPAWNCOUNT];

int TempSpawnIndexes[PLAYERMAX];

function int SamePoint(int point, int x, int y, int z, int a, int team)
{
    if (SpawnPoints[point][0] != x
     || SpawnPoints[point][1] != y
     || SpawnPoints[point][2] != z
     || SpawnPoints[point][3] != a
     || SpawnTeams[point]     != team)  { return 0; }

    return 1;
}

function int ValidSpawnIndex(void)
{
    int pln = PlayerNumber();
    int plt = GetPlayerInfo(pln, PLAYERINFO_TEAM) + 1;
    int i;
    int testtid = unusedTID(12000, 14000);
    int found = 0;

    for (i = 0; i < SPAWNCOUNT; i++)
    {
        if (SpawnTeams[i] != plt) { continue; }
        if (!Spawn("DoomPlayer", SpawnPoints[i][0], SpawnPoints[i][1], SpawnPoints[i][2], testtid)) { continue; }

        Thing_Remove(testtid);
        TempSpawnIndexes[found++] = i;
    }

    if (!found) { return -1; }

    return TempSpawnIndexes[random(0, found-1)];
}


function int RegisterSpawnIndex(void)
{
    int pln = PlayerNumber();

    int x = GetActorX(0);
    int y = GetActorY(0);
    int z = GetActorZ(0);
    int a = GetActorAngle(0);
    int team = GetPlayerInfo(pln, PLAYERINFO_TEAM) + 1;

    int i;
    int firstFree = -1;

    for (i = 0; i < SPAWNCOUNT; i++)
    {
        if (SpawnTeams[i] == 0 && firstFree == -1) { firstFree = i; }
        if (SamePoint(i, x, y, z, a, team)) { return -1; }
    }

    if (firstFree == -1) { return -1; }

    SpawnPoints[firstFree][0] = x;
    SpawnPoints[firstFree][1] = y;
    SpawnPoints[firstFree][2] = z;
    SpawnPoints[firstFree][3] = a;
    SpawnTeams[firstFree]     = team;
    return firstFree;
}
